"""Code generated by Speakeasy (https://speakeasy.com). DO NOT EDIT."""

from __future__ import annotations
from .batchstatus import BatchStatus
from pydantic import model_serializer
from syllable_sdk.types import (
    BaseModel,
    Nullable,
    OptionalNullable,
    UNSET,
    UNSET_SENTINEL,
)
from typing import Optional
from typing_extensions import NotRequired, TypedDict


class CommunicationBatchTypedDict(TypedDict):
    batch_id: str
    r"""Unique ID for conversation batch"""
    campaign_id: int
    r"""Unique ID for campaign"""
    last_updated_by: str
    r"""Email of user who last updated campaign"""
    expires_on: NotRequired[Nullable[str]]
    r"""Timestamp of batch expiration"""
    status: NotRequired[BatchStatus]
    r"""Status of a communication batch."""
    count: NotRequired[Nullable[int]]
    r"""Number of requests in batch"""
    created_at: NotRequired[str]
    r"""Timestamp of batch creation"""
    deleted_at: NotRequired[Nullable[str]]
    r"""Timestamp of batch deletion"""
    deleted_reason: NotRequired[Nullable[str]]
    r"""Reason for batch deletion"""
    last_worked_on: NotRequired[Nullable[str]]
    r"""Timestamp of last batch activity"""


class CommunicationBatch(BaseModel):
    batch_id: str
    r"""Unique ID for conversation batch"""

    campaign_id: int
    r"""Unique ID for campaign"""

    last_updated_by: str
    r"""Email of user who last updated campaign"""

    expires_on: OptionalNullable[str] = UNSET
    r"""Timestamp of batch expiration"""

    status: Optional[BatchStatus] = None
    r"""Status of a communication batch."""

    count: OptionalNullable[int] = UNSET
    r"""Number of requests in batch"""

    created_at: Optional[str] = None
    r"""Timestamp of batch creation"""

    deleted_at: OptionalNullable[str] = UNSET
    r"""Timestamp of batch deletion"""

    deleted_reason: OptionalNullable[str] = UNSET
    r"""Reason for batch deletion"""

    last_worked_on: OptionalNullable[str] = UNSET
    r"""Timestamp of last batch activity"""

    @model_serializer(mode="wrap")
    def serialize_model(self, handler):
        optional_fields = [
            "expires_on",
            "status",
            "count",
            "created_at",
            "deleted_at",
            "deleted_reason",
            "last_worked_on",
        ]
        nullable_fields = [
            "expires_on",
            "count",
            "deleted_at",
            "deleted_reason",
            "last_worked_on",
        ]
        null_default_fields = []

        serialized = handler(self)

        m = {}

        for n, f in type(self).model_fields.items():
            k = f.alias or n
            val = serialized.get(k)
            serialized.pop(k, None)

            optional_nullable = k in optional_fields and k in nullable_fields
            is_set = (
                self.__pydantic_fields_set__.intersection({n})
                or k in null_default_fields
            )  # pylint: disable=no-member

            if val is not None and val != UNSET_SENTINEL:
                m[k] = val
            elif val != UNSET_SENTINEL and (
                not k in optional_fields or (optional_nullable and is_set)
            ):
                m[k] = val

        return m
